/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006		by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2006-2008	by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: start.S 1157 2008-06-26 03:10:08Z ertl-yutaka $
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)     (val)        /* uint_tޥ */
#define ULONG_C(val)    (val)        /* ulong_tޥ */
#define CAST(type, val) (val)        /* 㥹ȤԤޥ */

#include "kernel_impl.h"		
#include "m32rasm.inc"

	/*
	 *  ȥåץ롼
	 */
	.globl		start

	.extern		_kernel_istkpt
	.extern		__vector_start
	.extern		hardware_init_hook
	.extern		software_init_hook
	.extern		__sbss
	.extern		__ebss
	.extern		__sidata
	.extern		__eidata
	.extern		__sdata
	.extern 	sta_ker

	.text
	.align 4		
start:
	/* PSW */
	ldi		r0, #0
	mvtc	r0, psw		/* ߶ػߡߥå */

	/* å */
	lea		r1, MCCR
	st		r0, @r1		/* åOFF */
	
	/* ߥåݥ󥿤ν */
	lea		r1, _kernel_istkpt
	ld		sp, @r1
		
	/* EVB */
	seth 	r0, #high(__vector_start)
	mvtc 	r0, cr5
				
	/* ϡɥ롼εư */
	lea		r0, hardware_init_hook
	beqz	r0, L1
	jl		r0

L1:
	/* .bssΥꥢ */
	xor		r0, r0
	lea		r1, __sbss
	lea		r2, __ebss
	beq		r1, r2, L3
L2:
	st		r0, @-r2
	bne		r1, r2, L2

L3:
	/* 
	 *  .dataν 
	 *
	 *  dataͤʤˤϡ¨¤˥եȥ롼
	 *  εư֡
	 */
	lea		r1, __sidata
	lea		r2, __eidata
	beq		r1, r2, L5
	lea		r3, __sdata
	addi	r3, #-4

L4:
	ld		r0, @r1+
	st		r0, @+r3
	bne		r1, r2, L4

L5:
	/* եȥ롼εư */
	lea		r0, software_init_hook
	beqz	r0, L6
	jl		r0

L6:
	/* CPUå֤ */	
	ld24 	r0, ICUIMASK+1
	ldi 	r1, #IIPM_LOCK
	stb 	r1, @r0 										

	/* ͥ뵯ư */
	bl		sta_ker
		
L7:	
	bra		L7
