/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2007		by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: target_support.S 1154 2008-06-26 02:45:42Z ertl-yutaka $
 */

/*
 *	åȥƥ¸⥸塼 ֥M3A-ZA36ѡ
 */

#define	TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "m32r_gcc/m32rasm.inc"

/*
 *	֥å쥯ȥȥ
 *
 *  ꡼ɻեȥȿ1
 *	åե꡼ɻեȥȿ0
 *  Х16ӥå
 *	饤Ȼեȥȿ1
 *  BSELȡʤ
 *  ȥֽϥߥӥåȡBSEL1BCLK
 *  ڡ̵
 *  READYԤʤ
 *  ꥫХꥵ롧
 *  ȿ0
 */
#define BSEL0CR_VAL	0x01011100

/*
 *	SDRAMޥ
 */

/*
 *  SDRAMեå쥸1׽
 *
 *  ȥեå塧ͭ
 *  ȥեå奵롧2
 *  ȥեå׵ֳ֡384
 *  ȥեå(DRFEN):1(ͭ
 *  ȥեå奦(DREFW): 8BCLK
 *  ȥեå׵ֳ(DRFC):	1344BCLK
*/

#define SDRF1_VAL	0x00010017	

/* 
 *  SDRAM쥸0
 *
 *  ץ㡼륦(DPC): 3
 *  ȥեå(DARFC):ػ
 *  ȥեåֳ(DARFI):4 
 */
#define	SDIR0_VAL	0x00000182	

/* 
 *  SDRAM쥸1
 *
 *  ơǤϤʤ
 *  󥹳ϡ
 */
#define SDIR1_VAL	0x00000001

/* 
 *  SDRAM0ɥ쥹쥸
 *  
 *  Ƭɥ쥹ӥåȡ001000(A3-A8)
 *  Х32ӥå
 *  ͥ륵64M
 */
#define	SD0ADR_VAL	0x04000004	

/* 
 *  SDRAM0ߥ󥰥쥸
 *  
 *  ƥִ֡3
 *  졼ƥ󥷡1
 *  ץ㡼֡1
 *  饤ȥꥫХ֡2
 *  SDRAMȥ饫졼ƥ󥷡2
 */
#define SD0TR_VAL	0x00020102

/*
 *  SDRAM0⡼ɥ쥸׽
 *  
 *  ⡼ɥ쥸0x20
 */
/* Сȥ⡼						*/
/* CL=2									*/
/* Сȥס󥷥		*/
/* СĹ							*/
#define SD0MOD_VAL	0x00000020

/*
 *  SDRAM0֥͡쥸
 *  
 *  SDRAMͭӥåȡͭ
 */
#define SD0ER_VAL	0x00000001
#if 0
	.text
	.globl hardware_init_hook
hardware_init_hook:

	/* 
	 *  SDRAM
	 */
	ld24	r2, #SDIR0
	lea		r3, SDIR0_VAL	
	st		r3, @r2

	/* SDRAM󥹳 */
	ld24	r2, #SDIR1
	lea		r3, SDIR1_VAL
	st		r3, @r2

	/* SDRAM󥹴λԤ */
wait_sdram:
	ldh		r3, @r2
	bnez	r3, wait_sdram

	/* SDRAM⡼ɥ쥸 */
	ld24	r2, SDMOD(0)		
	lea		r3, SD0MOD_VAL	
	st		r3, @r2

	/* ---- SDRAMߥ󥰥쥸 -- */
	ld24	r2, SDTR(0)
	lea		r3, SD0TR_VAL
	st      r3, @r2	

	/* --- SDRAMΰ(H'0400000032MХ,32bitBUS)	*/
	ld24	r2, SDADR(0)
	lea		r3, SD0ADR_VAL	
	st		r3, @r2

	/* ---- ȥեåͭ׵ֳ:1344å	*/
	ld24	r2, #SDRF1
	lea		r3, SDRF1_VAL	
	st		r3, @r2

	/* SDRAM֥͡쥸	*/
	ld24	r2, SDER(0)
	lea		r3, SD0ER_VAL
	st		r3, @r2
	rte

#endif
